精华内容
下载资源
问答
  • Linux命令长选项和短选项区别

    千次阅读 2017-03-07 16:35:51
    Linux命令的一般格式为 : $ command [option] [paraments] ...2)长选项(long options):由两个连字符和一些大小字母组合的单词构成,例如:--size,--help等。 通常,一个程序会提供

    Linux命令的一般格式为 :

    $ command  [option]  [paraments]

    对于选项(option)类型有两种:

    1)短选项(short option):由一个连字符和一个字母构成,例如:-a, -s等;

    2)长选项(long options):由两个连字符和一些大小写字母组合的单词构成,例如:--size,--help等。

    通常,一个程序会提供short option和long options两种形式,例如:ls -a,--all。另外,短选项(short option)是可以合并的,例如:-sh表示-s和-h的组合,如果要表示为一个选项需要用长选项--sh。

    不是所有的Linux命令都遵循以上的规则,例如:

    find -type d -mindepth 2

    参考:http://blog.csdn.net/hbhhww/article/details/6837700


    展开全文
  • Linux中命令选项及参数简介

    千次阅读 2018-01-15 19:45:33
    登录Linux后,我们就可以在#或$...command [options] [arguments] //中括号代表是可选的,即有些命令需要选项需要参数,但有的命令在运行时需要多个选项或参数。 选项options: 选项是调整命令执行行为的开关

    登录Linux后,我们就可以在#或$符后面去输入命令,有的时候命令后面还会跟着“选项”(英文options)或“参数”(英文arguments)。即Linux中命令格式为:

    command [options] [arguments] //中括号代表是可选的,即有些命令不需要选项也不需要参数,但有的命令在运行时需要多个选项或参数。

    选项options:

    选项是调整命令执行行为的开关,即,选项不同决定了命令的显示结果不同。

    选项分为长选项和短选项。

    短选项:比如-h,-l,-s等。(-   后面接单个字母)

      l短选项都是使用‘-’引导,当有多个短选项时,各选项之间使用空格隔开。

      l有些命令的短选项可以组合,比如-l –h 可以组合为–lh

      l有些命令的短选项可以不带-,这通常叫作BSD风格的选项,比如ps aux

      l有些短选项需要带选项本身的参数,比如-L 512M

    长选项:比如--help,--list等。(--  后面接单词)

      l长选面都是完整的单词

      l长选项通常不能组合

      l如果需要参数,长选项的参数通常需要‘=’,比如--size=1G

    参数arguments:

      参数是指命令的作用对象。

      如ls命令,不加参数的时候显示是当前目录,也可以加参数,如ls /dev, 则输出结果是/dev目录。

      以上简要说明了选项及参数的区别,但具体Linux中哪条命令有哪些选项及参数,需要我们靠经验积累或者查看Linux的帮助了。

     

    总结:

      选项是限定结果的显示结果  

        短选项(-  一个横杠):只能修饰一个字符的选项,比如: ls -a,当然多个短选项可以合并,比如tar -cvf

        长选项(--  两个横杠):可以修饰单个字符,也可以修饰一个单词,比如:(1) chkconfig --list   (2)chkconfig --add xxx  (3)service --status-all

      参数是传递到脚本中的真实的参数

     

     

    第二种理解:

    本文介绍了linux shell中使用命令行选项与命令行参数的方法,在bash中,可以用以下三种方式来处理命令

    行参数,每种方式都有自己的应用场景
    问题描述:在linux shell中如何处理tail -n 10 access.log这样的命令行选项?
    在bash中,可以用以下三种方式来处理命令行参数,每种方式都有自己的应用场景。
    1,直接处理,依次对$1,$2,...,$n进行解析,分别手工处理;
    2,getopts来处理,单个字符选项的情况(如:-n 10 -f file.txt等选项);
    3,getopt,可以处理单个字符选项,也可以处理长选项long-option(如:--prefix=/home等)。
    总结:小脚本手工处理即可,getopts能处理绝大多数的情况,getopt较复杂、功能也更强大。
    1,直接手工处理位置参数
    必须要要知道几个变量,
    代码如下:

    *    $0 :即命令本身,相当于c/c++中的argv[0]  
    *    $1 :第一个参数.  
    *    $2, $3, $4 ... :第2、3、4个参数,依次类推。  
    *    $#  参数的个数,不包括命令本身  
    *    $@ :参数本身的列表,也不包括命令本身  
    *    $* :和$@相同,但"$*""$@"(加引号)并不同,"$*"将所有的参数解释成一个字符串,而"$@"  

     

    是一个参数数组。


    手工处理方式能满足多数的简单需求,配合shift使用也能构造出强大的功能,但处理复杂选项时建议用下面

    的两种方法。
    例子,(getargs.sh):
    代码如下:

    复制代码
    #!/bin/bash  
    if [ $# -lt 1 ]; then  
        echo "error.. need args"  
        exit 1  
    fi  
    echo "commond is $0"  
    echo "args are:"  
    for arg in "$@"  
    do  
        echo $arg  
    done  
    复制代码

     

     

     



    运行命令:
    代码如下:


     
    ./getargs.sh 11 22 cc  
    commond is ./getargs.sh  
    args are:  
    11  
    22  
    cc  

     



    2,getopts (shell内置命令)
    处理命令行参数是一个相似而又复杂的事情,为此,c提供了getopt/getopt_long等函数,c++的boost提供了

    options库,在shell中,处理此事的是getopts和getopt。
    getopts/getopt的区别,getopt是个外部binary文件,而getopts是shell builtin。

    代码如下:

    [root@jbxue ~]$ type getopt  
    getopt is /usr/bin/getopt  
    [root@jbxue ~]$ type getopts  
    getopts is a shell builtin  

     

     

    getopts不能直接处理长的选项(如:--prefix=/home等)
    关于getopts的使用方法,可以man bash  搜索getopts
    getopts有两个参数,第一个参数是一个字符串,包括字符和“:”,每一个字符都是一个有效的选项,如果

    字符后面带有“:”,表示这个字符有自己的参数。getopts从命令中获取这些参数,并且删去了“-”,并

    将其赋值在第二个参数中,如果带有自己参数,这个参数赋值在“optarg”中。提供getopts的shell内置了

    optarg这个变变,getopts修改了这个变量。
    这里变量$optarg存储相应选项的参数,而$optind总是存储原始$*中下一个要处理的元素位置。
    while getopts ":a:bc" opt  #第一个冒号表示忽略错误;字符后面的冒号表示该选项必须有自己的参数
    例子,(getopts.sh):

    代码如下:

    复制代码
    echo $*  
    while getopts ":a:bc" opt  
    do  
            case $opt in  
                    a ) echo $optarg  
                        echo $optind;;  
                    b ) echo "b $optind";;  
                    c ) echo "c $optind";;  
                    ? ) echo "error"  
                        exit 1;;  
            esac  
    done  
    echo $optind  
    shift $(($optind - 1))  
    #通过shift $(($optind - 1))的处理,$*中就只保留了除去选项内容的参数,可以在其后进行正常的shell  
      
    编程处理了。  
    echo $0  
    echo $*  
    复制代码

     


     

     





    执行命令:

    复制代码 代码如下:

     

    复制代码
    ./getopts.sh -a 11 -b -c  
    -a 11 -b -c  
    11  
    3  
    b 4  
    c 5  
    5  
    ./getopts.sh  
    复制代码

     

     


     

    3,getopt(一个外部工具)
    具体用用法可以 man getopt
    #-o表示短选项,两个冒号表示该选项有一个可选参数,可选参数必须紧贴选项,如-carg 而不能是-c arg
    #--long表示长选项
    例子,(getopt.sh):

    代码如下:

    复制代码
    #!/bin/bash  
    # a small example program for using the new getopt(1) program.  
    # this program will only work with bash(1)  
    # an similar program using the tcsh(1) script. language can be found  
    # as parse.tcsh  
    # example input and output (from the bash prompt):  
    # ./parse.bash -a par1 'another arg' --c-long 'wow!*\?' -cmore -b " very long "  
    # option a  
    # option c, no argument  
    # option c, argument `more'  
    # option b, argument ` very long '  
    # remaining arguments:  
    # --> `par1'  
    # --> `another arg'  
    # --> `wow!*\?'  
    # note that we use `"$@"' to let each command-line parameter expand to a  
    # separate word. the quotes around `$@' are essential!  
    # we need temp as the `eval set --' would nuke the return value of getopt.  
    #-o表示短选项,两个冒号表示该选项有一个可选参数,可选参数必须紧贴选项  
    #如-carg 而不能是-c arg  
    #--long表示长选项  
    #"$@"在上面解释过  
    # -n:出错时的信息  
    # -- :举一个例子比较好理解:  
    #我们要创建一个名字为 "-f"的目录你会怎么办?  
    # mkdir -f #不成功,因为-f会被mkdir当作选项来解析,这时就可以使用  
    # mkdir -- -f 这样-f就不会被作为选项。  
    temp=`getopt -o ab:c:: --long a-long,b-long:,c-long:: \  
         -n 'example.bash' -- "$@"`  
    if [ $? != 0 ] ; then echo "terminating..." >&2 ; exit 1 ; fi  
    # note the quotes around `$temp': they are essential!  
    #set 会重新排列参数的顺序,也就是改变$1,$2...$n的值,这些值在getopt中重新排列过了  
    eval set -- "$temp"  
    #经过getopt的处理,下面处理具体选项。  
    while true ; do  
            case "$1" in  
                    -a|--a-long) echo "option a" ; shift ;;  
                    -b|--b-long) echo "option b, argument \`$2'" ; shift 2 ;;  
                    -c|--c-long)  
                            # c has an optional argument. as we are in quoted mode,  
                            # an empty parameter will be generated if its optional  
                            # argument is not found.  
                            case "$2" in  
                                    "") echo "option c, no argument"; shift 2 ;;  
                                    *)  echo "option c, argument \`$2'" ; shift 2 ;;  
                            esac ;;  
                    --) shift ; break ;;  
                    *) echo "internal error!" ; exit 1 ;;  
            esac  
    done  
    echo "remaining arguments:"  
    for arg do  
       echo '--> '"\`$arg'" ;  
    done  
    复制代码

     

     

     



    运行命令:
    代码如下:

    1
    2
    3
    4
    5
    6
    ./getopt.sh --b-long abc -a -c33 remain 
    option b, argument `abc' 
    option a 
    option c, argument `33' 
    remaining arguments: 
    --> `remain'

      

     

     

    转载自:https://www.cnblogs.com/qlqwjy/p/7787156.html

    展开全文
  • linux grep常用选项总结

    千次阅读 2013-11-22 10:53:41
    -i 区分大小(只适用于单字符)。 -h 查询多文件时显示文件名。 -l 查询多文件时只输出包含匹配字符的文件名。 -n 显示匹配行及行号。 -s 显示存在或无匹配文本的错误信息。 -v 显示包含匹配文本的所有...

    常用的grep选项有:
    -c 只输出匹配行的计数。
    -i 不区分大小写(只适用于单字符)。
    -h 查询多文件时不显示文件名。
    -l 查询多文件时只输出包含匹配字符的文件名。
    -n 显示匹配行及行号。
    -s 不显示不存在或无匹配文本的错误信息。
    -v 显示不包含匹配文本的所有行。


    备注:

    1)\>使用grep抽取精确匹配的一种更有效方式是在抽取字符串后加\>

    2)在grep命令中使用-v选项可丢弃ps命令中的grep进程,如下:

    [root@mysql shell]# ps ax | grep "crond"
     1571 ?        Ss     0:06 crond
    20971 pts/0    S+     0:00 grep crond
    [root@mysql shell]# ps ax | grep "crond" | grep -v "grep"
     1571 ?        Ss     0:06 crond



    展开全文
  • linux gcc链接选项详解

    千次阅读 2018-11-04 09:11:17
    动态可执行程序中包含运行所需的所有函数,linux的动态装入器负责装入动态链接的可执行程序运行所需的共享库。 动态装入器找到共享库要依靠两个文件 — /etc/ld.so.conf 和 /etc/ld.so.cache。 $ cat /etc/ld...

    -I(大写i) -L(大写L) -l(小写l)
    (1)-l -I(大写i)
    显示指定头文件的搜索路径。

     -I/home/myinclude/ 表示/home/myinclude目录作为第一个寻找头文件的目录,寻找的顺序是:
     /home/myinclude/ -->/usr/include -->/usr/local/include
    

    (2)
    -L(大写l)
    显示指定程序按照 -L 指定的路径去寻找库文件。

    -I/home/lib/ 表示/home/mylib目录作为第一个寻找库文件的目录,寻找的顺序是:
    /home/mylib-->/lib-->/usr/lib-->/usr/local/lib
    

    (3)
    -l(小写)
    指定在上述的lib的路径中寻找*.so动态库文件

    -lsqlite3 -lpthread -lcrypto ,-l后面跟着的是动态库的名字,到上述的lib目录寻找libsqlite3.so、pthread.so ,crypto.so动态库文件。
    

    LIBRARY_PATH, LD_LIBRARY_PATH 与ld.so.conf

    LIBRARY_PATH和LD_LIBRARY_PATH是Linux下的两个环境变量,二者的含义和作用分别如下:

    LIBRARY_PATH环境变量用于在程序编译期间查找动态链接库时指定查找共享库的路径,例如,指定gcc编译需要用到的动态链接库的目录。设置方法如下(其中,LIBDIR1和LIBDIR2为两个库目录):

    export LIBRARY_PATH=LIBDIR1:LIBDIR2:$LIBRARY_PATH
    

    LD_LIBRARY_PATH环境变量用于在程序加载运行期间查找动态链接库时指定除了系统默认路径之外的其他路径,注意,LD_LIBRARY_PATH中指定的路径会在系统默认路径之前进行查找。设置方法如下(其中,LIBDIR1和LIBDIR2为两个库目录):

    export LD_LIBRARY_PATH=LIBDIR1:LIBDIR2:$LD_LIBRARY_PATH
    

    在linux下,还可以将动态链接目录加到/etc/ld.so.conf中,在 /etc/ld.so.conf中写下“想要读入高速缓存中的动态函数库所在的目录”,注意,是目录而不是文件。然后调用ldconfig。

    动态可执行程序中不包含运行所需的所有函数,linux的动态装入器负责装入动态链接的可执行程序运行所需的共享库。
    动态装入器找到共享库要依靠两个文件 — /etc/ld.so.conf 和 /etc/ld.so.cache。

    $ cat /etc/ld.so.conf
      /usr/X11R6/lib
      /usr/lib/gcc-lib/i686-pc-linux-gnu/2.95.3
      /usr/lib/mozilla
      /usr/lib/qt-x11-2.3.1/lib
      /usr/local/lib
    

    ld.so.conf 文件包含一个所有目录(/lib 和 /usr/lib 除外,它们会自动包含在其中)的清单,动态装入器将在其中查找共享库,LD_LIBRARY_PATH即是指示动态装入器首先检查某个目录。但是在动态装入器能“看到”这一信息之前,必须将它转换到 ld.so.cache 文件中。可以通过运行 ldconfig 命令做到这一点:
    ldconfig
      当 ldconfig 操作结束时,系统生成最新的 /etc/ld.so.cache 文件,反映出 /etc/ld.so.conf 所做的更改。从这一刻起,动态装入器在寻找共享库时会查看您在 /etc/ld.so.conf 中指定的所有新目录。

    展开全文
  • 修改linux内核编译选项

    千次阅读 2004-11-15 16:47:00
    修改linux内核编译选项make menuconfig时,程序会读取各个目录下的Config.in文件来生成内核配置对话框。以fs目录下的Config.in文件为例。bool Quota support CONFIG_QUOTAbool POSIX Access Control List support ...
  • linux命令gcc常用选项

    万次阅读 2020-08-23 16:01:00
    linux下调试时gcc用的非常比较,下面看gcc常用选项。 E 激活预处理;头文件、宏等展开(.i文件) S 激活预处理、编译;生成汇编代码(.s文件) c 激活预处理、编译、汇编;生成目标文件(.o文件) o 生成...
  • Linux说明文档usage选项的说明

    千次阅读 2019-08-08 19:47:10
    对于Linux初学者,查看帮助文档对于提升自己有很大的帮助。 特别对于usage来说,只有看懂了用法,才能够学会它。 1.在usage中,option有如下...在方括号和大括号中的内容是必选项 2.options中的命令选项有两种形式...
  • linux tar指令常用选项

    千次阅读 2016-06-11 14:01:45
    linux的tar指令经常被用到,因为压缩文件的时候通常需要打包文档,而tar指令就是打包指令,同时gzip压缩程序和bzip2压缩程序都是支持tar指令的,所以tar指令在打包的同时还可以用gzip和bzip进行压缩,这样多文件可以...
  • linux gcc常用编译选项总结

    万次阅读 2018-03-28 15:57:31
    对于编译源码,Makefile中会用到大量的gcc选项,所以熟悉gcc编译选项对于学习Makefile至关重要。 -c:只激活预处理,编译,和汇编,也就生成obj文件-S:只激活预处理和编译,就是指把文档编译成为汇编代码。-E:只激活...
  • Kali Linux安装界面选项的说明

    千次阅读 2018-04-23 15:25:25
    Live - Live boot, as ususal.Live (failsafe) - boots with a minimal set of drivers and hardware checks.Live (forensics) - Boots without mounting anything, suitable for forensics work.Live USB Persisten...
  • linux gcc编译优化选项

    千次阅读 2019-04-18 14:07:27
    O0选项不进行任何优化,在这种情况下,编译器尽量的缩短编译消耗(时间,空间),此时,debug会产出和程序预期的结果。当程序运行被断点打断,此时程序内的各种声明是独立的,我们可以任意的给变量赋值,或者在函数...
  • ls命令选项 文章目录ls命令选项1. ls命令选项使用2. 小结 学习目标 能够说出查看目录中隐藏文件的命令选项 1. ls命令选项使用 命令选项 说明 -l 以列表方式显示 -h 件大小单位显示,默认是字节 -a ...
  • Linux基础之linux常用命令(含命令的部分选项

    千次阅读 多人点赞 2020-11-18 20:19:29
    目录一、linux简介1)linux的特殊程序----Shell2)linux命令的分类3)linux命令行格式4)编辑linux命令行的辅助操作5)命令帮助 一、linux简介 1)linux的特殊程序----Shell shell是linux系统中运行的一种特殊程序 ...
  • Linux常用基本命令及选项参数总结

    万次阅读 2020-05-17 11:00:32
    mv命令 功能:用于重命名或者移动文件或目录 格式:mv [ 选项 ] 源文件或目录 目标文件或目录 选项 功能 -b 为每个已存在的目标文件创建备份 -f 覆盖前询问 -i 覆盖前询问 -n 覆盖已存在的文件,如果用户制定了...
  • 查看Linux系统内核编译选项

    千次阅读 2016-01-28 21:28:03
    查看Linux内核编译配置有时候我们需要查看Linux系统的内核是否在编译的时候的编译选项,从而确定某个模块是否已经加入到内核以及参数设置等等。 方法有两种: # zcat /proc/config.gz # cat /boot/config-$(uname -r...
  • #!/bin/bash if [ $# -lt 1 ]; then echo "error.. need args" exit 1 fi echo "commond is $0" echo "args are:" for arg in "$@" do echo $arg done
  • Linux自然也是这样做的。 所以你会发现自己在Linux下执行命令行命令的时候,很少会有信息打印在终端上。(这里的打印就是输出的意思) 哈姆雷特说:生存或毁灭,这是一个值得考虑的问题。 unix说:显示或者显示...
  • 本文介绍了linux shell中使用命令行选项与命令行参数的方法,在bash中,可以用以下三种方式来处理命令 行参数,每种方式都有自己的应用场景 问题描述:在linux shell中如何处理tail -n 10 access.log这样的...
  • Linux开机界面出现多个选项

    千次阅读 2018-08-10 08:42:24
     前俩个是选项是正常启动项,第三个选项是急救模式启动(系统出项问题能正常启动时使用并修复系统)  进入默认的第一个选项报错 Kernel Panic - not syncing: VFS: Unable to mount root fs on unknown-block ...
  • 查看运行中Linux的内核配置选项

    千次阅读 2016-03-15 19:41:33
    0x01 查看内核配置选项zcat /proc/config.gz 需要开启内核配置项CONFIG_IKCONFIG才会生成这个文件
  • linux命令之grep的-o选项

    万次阅读 2017-10-07 22:04:47
    这个选项说的是, 只输出匹配的部分, 在shell抓取网页内容时, 开始知道这个选项, 后来居然用上了perl的HTML::TokeParser, 我只想说, 喜新厌旧是人类最好的品质, 不然怎么来那么多创新…(心里一阵自嘲), 虽然走...
  • 安装fedora时,使用dnf update更新了内核版本后未删除旧的内核,所以启动时有两个选项。 删除旧内核可以按顺序在终端运行: rpm -qa | grep kernel #这个命令用来查看系统已安装rpm包中带有kernel关键字的包 rpm ...

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 710,125
精华内容 284,050
关键字:

linux不写选项

linux 订阅